class Fakul {
	static int convertInput(String instr) throws BadFactorialArgException {
		int arg;
		try {
			arg = Integer.parseInt(instr);
			if (arg < 0  || arg > 170)
				throw new BadFactorialArgException(
					"Unzulässiges Argument (erlaubt: 0 bis 170)", instr, 3, arg);
			else
				return arg;
		} catch (NumberFormatException e) {
			throw new BadFactorialArgException("Fehler beim Konvertieren", instr, 2, -1);
		}
	}

	public static void main(String[] args) {
		int argument = -1;
	
		try {
			if (args.length == 0)
				throw new BadFactorialArgException("Kein Argument angegeben", "", 1, -1);
			argument = convertInput(args[0]);
			double fakul = 1.0;
			for (int i = 1; i <= argument; i++)
				fakul = fakul * i;
			System.out.println("Fakultät: " + fakul);
		} catch (BadFactorialArgException e) {
			System.out.println("Fehler: " + e.getError() + " " + e.getMessage());
			switch (e.getError()) {
				case 2 :	System.out.println("Zeichenfolge: \"" + e.getInstr() + "\"");
							break;
				case 3 :	System.out.println("Wert: " + e.getValue());
							break;
			}
		}
	}
}
