import java.util.function.Supplier;

class LambdaScoping {
	static int statEnc = 0;
	int instEnc = 10;
	Supplier<String> sups;
	
	LambdaScoping() {
		int locEnc = 13;
		int[] locArrEnc = {100};
	
		// Interface-Implementation per Lambda-Ausdruck
		sups = () -> {
			 // int locEnc = 14; // Verboten, weil sich der Lambda-Ausdruck im Gültigkeitsbereich der umgebenden Methode befindet.
			 return String.valueOf(++statEnc)+" "+
		           String.valueOf(++instEnc)+" "+
			       String.valueOf(locEnc)+" "+ // ++locEnc für die Variable aus der lokalen Umgebung ist verboten
			       String.valueOf(++locArrEnc[0]);
			};
		
		// Interface-Implementation durch eine anonyme Klasse
//		sups = new Supplier<String>() {
//			public String get() {
//				int locEnc = 14; // In der anonymen Klasse erlaubt, weil sie einen eigenen Gültigkeitsbereich hat.
//				return String.valueOf(++statEnc)+" "+
//			           String.valueOf(++LambdaScoping.this.instEnc)+" "+
//				       String.valueOf(locEnc)+" "+ // ++locEnc für die Variable aus der lokalen Umgebung ist verboten
//				       String.valueOf(++locArrEnc[0]);
//			}
//		 };
	}

	void clientWork() {
		System.out.println(sups.get());
	}

	public static void main(String[] args) {
		LambdaScoping ls = new LambdaScoping();
		ls.clientWork(); ls.clientWork(); ls.clientWork();
	}
}
