import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Optional;
import java.util.OptionalInt;
import java.util.stream.IntStream;

class Reduce {
	public static void main(String[] args) {
		
		// Summe der quadrierten natürlichen Zahlen via Stream<Integer>
		Optional<Integer> sq1 = Arrays.asList(1,2,3)
				.stream()
				.map(i -> i*i)
				.reduce((c,i) -> c+i);
		System.out.println("Stream<Integer>: " + (sq1.isPresent() ? sq1.get():"Fehler"));

		// Summe der quadrierten natürlichen Zahlen via IntStream
		OptionalInt sq2 = IntStream
				.range(1,4)
				.map(i -> i*i)
				.reduce((c,i) -> c+i);
		System.out.println("IntStream: " + (sq2.isPresent() ? sq2.getAsInt():"Fehler"));
		
		// Summe der quadrierten natürlichen Zahlen per average-Operation
		int sq3 = IntStream
				.range(1,4)
				.map(i -> i*i)
				.sum();
		System.out.println("sum: "+sq3);
		
//		IntFunction<BigDecimal> mapper = new IntFunction<BigDecimal>() {
//			public BigDecimal apply(int i) {
//				return new BigDecimal(i);
//			}
//		};
		
		// Fakultät per Stream<BigDecimal>
		long start = System.currentTimeMillis();
		BigDecimal fak = IntStream
				.rangeClosed(1,50_000)
//				.parallel()
				.mapToObj(BigDecimal::new)
//				.<BigDecimal>mapToObj(new IntFunction<BigDecimal>() {
//					public BigDecimal apply(int i) {
//						return new BigDecimal(i);
//					}
//				})
				.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
		System.out.printf("\nFakultät: %e\nZeit in Millisekunden: %d",
				          fak, System.currentTimeMillis()-start);
	}
}
