public class GenMax {
	
	public static <T extends Comparable<T>> T max(T x, T y) {
		return x.compareTo(y) > 0 ? x : y;
	}

//	static <T extends Comparable<T>> T max(T[] ar) {
//		if (ar.length == 0)
//			return null;
//		T max = ar[0];
//		for(T a : ar)
//			if (a.compareTo(max) > 0)
//				max = a;
//		return max;
//	}

	public static <T extends Comparable<T>> T max(T ... ar) {
		if (ar.length == 0)
			return null;
		T max = ar[0];
		for(T a : ar)
			if (a.compareTo(max) > 0)
				max = a;
		return max;
	}

	public static void main(String[] args) {
		System.out.println("Max. von int-Serie\t\t" + max(4, 777, 11, 81));
		System.out.println("Max. von double-Serie\t\t" + max(4.0, 777.0, 11.0, 81.0));
		System.out.println("Max. Elem. im Integer-Array:\t" + max(new Integer[] {11, 7, 4, 45, 5}));
		// System.out.println("Max. Elem. im Integer-Array:\t" + max(new int[] {11, 7, 4, 45, 5})); // verboten
	}
}

