class SimpleListTest {
	public static void main(String[] args) throws Exception {
		
		SimpleList<String> sls = new SimpleList<>(3);
		sls.add("Otto");
		sls.add("Rempremmerding");
		System.out.println("Länge: "+sls.size()+", Kapazität: "+sls.capacity());
		sls.add("Hans");
		sls.add("Brgl");
		System.out.println("Länge: "+sls.size()+", Kapazität: "+sls.capacity());
		for (int i=0; i < sls.size();i++)
			System.out.println(sls.get(i));

//		// Zuweisungskompatibilität
//		SimpleList<Object> slObject =  new SimpleList<String>(3);  //verboten
//		SimpleList slObject = new SimpleList<String>(3); // erlaubt, aber gefährlich und sinnlos
		
//		// Kovarianz und mangelnde Typsicherheit bei Arrays
//		Object[] arrObject = new String[5];
//		arrObject[0] = 13;
//		System.out.println(arrObject[0]);

		
//		// Keine Konkretisierung von Typformalparametern durch primitive Typen
//		SimpleList<int> si = new SimpleList<>(); // nicht möglich
//		SimpleList<Integer> si = new SimpleList<>(); // Ersatzlösung
		
//		// Wildcard-Typen, ungebunden
//		SimpleList<?> slWCU;
//		SimpleList<String> slString = new SimpleList<String>(5);
//		slString.add("Emma");
//		slWCU = slString;
//		System.out.println(slWCU.get(0));

		// Wildcard-Typen, gebunden		
//		SimpleList<? extends Number> slNumber;
//		SimpleList<Integer> slInteger = new SimpleList<Integer>(5);
//		slInteger.add(4711);
//		slNumber = slInteger;
//		Number num = slNumber.get(0); 
//		System.out.println(num);

//		//  verboten: Einfügen via Wildcard-Referenz
//		slNumber.add(13);

//		// Typlöschung und Typprüfung per instanceof - Operator
//		System.out.println(sls.getClass());
//		System.out.println(sls instanceof SimpleList);
//		System.out.println(sls instanceof SimpleList<?>);
//		// System.out.println(sls instanceof SimpleList<String>); // nicht erlaubt		
		
	}
}
