import java.util.Arrays;

public class SimpleSortedList<E extends Comparable<E>> {
	private E[] elements;
	private final static int DEF_INIT_SIZE = 16;
	private int initSize;
	private int size;
	
	@SuppressWarnings("unchecked")
	public SimpleSortedList(int len) {
		if (len > 0) {
			initSize = len;
			elements = (E[]) new Comparable[len];
		} else {
			initSize = DEF_INIT_SIZE;
			elements = (E[]) new Comparable[DEF_INIT_SIZE];
		}
	}
	
	@SuppressWarnings("unchecked")
	public SimpleSortedList() {
		initSize = DEF_INIT_SIZE;
		elements = (E[]) new Comparable[DEF_INIT_SIZE];
	}
	
	public void add(E element) {
		if (size == elements.length)
			elements = Arrays.copyOf(elements, elements.length + initSize);
		boolean inserted = false;
		for (int i = 0; i < size; i++) {
			if (element.compareTo(elements[i]) <= 0) {
				for (int j = size; j > i; j--)
					elements[j] = elements[j-1];
				elements[i] = element;
				inserted = true;
				break;
			}
		}
		if (!inserted)
			elements[size] = element;
		size++;
	}
	
	public E get(int index) {
		if (index >= 0 && index < size)
			return elements[index];
		else
			return null;
	}

	public void addList(SimpleSortedList<? extends E> list) {
		if (size + list.size > elements.length)
			elements = Arrays.copyOf(elements, size + list.size + initSize);
		for (int i = 0; i < list.size; i++)
			elements[size++] = list.get(i);
	}	

	public void wcTest(SimpleSortedList<? extends E> parlis) {
		E com = parlis.get(0);
		System.out.println(com.compareTo(parlis.get(1)));
//		parlis.get(0).compareTo(parlis.get(1));
	}	

	
	public int size() {return size;}

	public int capacity() {return elements.length;}
}
