import java.io.*;
import java.nio.file.*;

class DataOutputStreamDemo {
	public static void main(String[] args) {
		Path file = Paths.get("demo.dat");

		// int, double und String schreiben
		try	(DataOutputStream dos = new DataOutputStream(Files.newOutputStream(file))) {
			dos.writeInt(4711);
			dos.writeDouble(Math.PI);
			dos.writeUTF("DataOutputStream-Demo");
		} catch (IOException ioe) {
			System.err.println(ioe);
			System.exit(1);
		} 
		
		// int, double und String lesen
		try (DataInputStream dis = new DataInputStream(Files.newInputStream(file))) {
			System.out.println("readInt() - Ergebnis:\t\t"+dis.readInt()+
							   "\nreadDouble() - Ergebnis:\t"+dis.readDouble()+
							   "\nreadUTF() - Ergebnis:\t\t"+dis.readUTF());
		} catch (IOException ioe) {
			System.err.println(ioe);
		}
	}
}