package de.zimk.attendance;
	
import java.util.Comparator;

import javafx.application.Application;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;
import javafx.geometry.Insets;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextField;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;

public class Attendance extends Application {
	final private int DIST = 10;

	@Override
	public void start(Stage primaryStage) {

		// Demonstrationsfälle
		final String[] anwesend = new String[] {"Willi", "Otto", "Theo", "Irma", "Doro", "Heiner", "Michael", "Ludger", "Ben"};
		
		final ObservableList<String> persons = FXCollections.observableArrayList(anwesend);
		final SortedList<String> perSorted = new SortedList<>(persons, Comparator.naturalOrder());
		final ListView<String> lvPersons = new ListView<>(perSorted);

		final GridPane root = new GridPane();
		// Gitterlinien anzeigen
//		root.setGridLinesVisible(true);
		
		// Randabstand für den Inhalt
		root.setPadding(new Insets(DIST, DIST, DIST, DIST));
		// Abstand zwischen den Bedienelementen
		root.setHgap(DIST); root.setVgap(DIST);
		
		final Label lblName = new Label("Name:");
		final Label lblPresent = new Label("Anwesend:");
		final TextField tfName = new TextField();
		
		final Button btnAdd = new Button("Angekommen");
		btnAdd.setOnAction(event -> {
			String s = tfName.getText();
			if (s.length() > 0)
				persons.add(s);
		});
		
		final Button btnRemove = new Button("Gegangen");
		btnRemove.setOnAction(event -> persons.remove(lvPersons.getSelectionModel().getSelectedItem()));
		
		root.add(lblName, 0, 0); root.add(tfName, 1, 0); root.add(btnAdd, 2, 0);
		root.add(lblPresent, 0, 1); root.add(lvPersons, 1, 1); root.add(btnRemove, 2, 1);

		// Dynamische Platzvergabe
		GridPane.setVgrow(lvPersons, Priority.ALWAYS);
		GridPane.setHgrow(tfName, Priority.ALWAYS);
		
		final Scene scene = new Scene(root, 450, 200);
		primaryStage.setScene(scene);
		primaryStage.setTitle("Anwesenheitskontrolle");
		primaryStage.show();
	}

	
	public static void main(String[] args) {
		launch(args);
	}
	
//	@Override
//	public void stop() {
//		Alert alert = new Alert(AlertType.INFORMATION, "Vielen Dank für den Einsatz dieser Software!");
//		alert.setHeaderText("Auf Wiedersehen!");
//		alert.showAndWait();
//	}
}
