import javafx.beans.Observable;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ListChangeListener;
import javafx.collections.ObservableList;

public class ObservableListDemo {
	public static void main(String[] args) {
		
		final ObservableList<StringProperty> ols =  FXCollections.observableArrayList(e -> new Observable[] {e});
		
		ols.addListener( new ListChangeListener<StringProperty>() {
			@Override
			public void onChanged(javafx.collections.ListChangeListener.Change<? extends StringProperty> c) {
				while (c.next()) {
					if (c.wasRemoved())
						System.out.println("Entfernt: "+c.getRemoved());
					if (c.wasAdded())
						System.out.println("Ergänzt: "+c.getAddedSubList());
					if (c.wasUpdated()) {
						int i = c.getFrom();
						System.out.println("Neuer Wert von Element "+i+": "+c.getList().get(i).get());
					}
				}
			}
		});
		
		final StringProperty spa = new SimpleStringProperty("A");
		final StringProperty spa1 = new SimpleStringProperty("A1");
		final StringProperty spb = new SimpleStringProperty("B");
		final StringProperty spc = new SimpleStringProperty("C");
		
		System.out.println("\n3 Elemente aufnehmen:");
		ols.addAll(spa, spb, spc);

		System.out.println("\nEin Element ersetzen:");		
		ols.set(0, spa1);

		System.out.println("\nEin Element ändern:");		
		ols.get(1).set("B1");
		
		System.out.println("\n2 nicht hintereinander liegende Elemente entfernen:");
		ols.removeAll(spa1, spc);
	}
}
