import java.time.Year;

import javafx.beans.binding.Bindings;
import javafx.beans.binding.IntegerBinding;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.ReadOnlyIntegerWrapper;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;

public class Person {
	private static int count = 0;
	private ReadOnlyIntegerWrapper id = new ReadOnlyIntegerWrapper(this, "id", ++count);
	private StringProperty firstName = new SimpleStringProperty(this, "firstName", "");
	private StringProperty lastName = new SimpleStringProperty(this, "lastName", "");
	private IntegerProperty yearOfBirth = new SimpleIntegerProperty(this, "yearOfBirth", -99);
	private IntegerProperty age = new SimpleIntegerProperty(this, "age", -99);

	public Person(String first, String last, int yOB) {
		firstName.setValue(first);
		lastName.setValue(last);
		yearOfBirth.setValue(yOB);
//		// Berechnung über das Fluent API
//		IntegerBinding ib = yearOfBirth.subtract(Year.now().getValue()).negate();
//		age.bind(ib);
		// Berechnung mit Hilfe der Klasse Bindings
		age.bind(Bindings.subtract(Year.now().getValue(), yearOfBirth));
	}

	public final javafx.beans.property.ReadOnlyIntegerProperty idProperty() {
		return this.id.getReadOnlyProperty();
	}
	

	public final int getId() {
		return this.idProperty().get();
	}
	

	public final StringProperty firstNameProperty() {
		return this.firstName;
	}
	

	public final java.lang.String getFirstName() {
		return this.firstNameProperty().get();
	}
	

	public final void setFirstName(final java.lang.String firstName) {
		this.firstNameProperty().set(firstName);
	}
	

	public final StringProperty lastNameProperty() {
		return this.lastName;
	}
	

	public final java.lang.String getLastName() {
		return this.lastNameProperty().get();
	}
	

	public final void setLastName(final java.lang.String lastName) {
		this.lastNameProperty().set(lastName);
	}
	

	public final IntegerProperty yearOfBirthProperty() {
		return this.yearOfBirth;
	}
	

	public final int getYearOfBirth() {
		return this.yearOfBirthProperty().get();
	}
	

	public final void setYearOfBirth(final int yearOfBirth) {
		this.yearOfBirthProperty().set(yearOfBirth);
	}
	

	public final IntegerProperty ageProperty() {
		return this.age;
	}
	

	public final int getAge() {
		return this.ageProperty().get();
	}
	

	public final void setAge(final int age) {
		this.ageProperty().set(age);
	}
}
