import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ContentDisplay;
import javafx.scene.control.Label;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.VBox;

public class BasicControls extends Application {
	private int numClicks = 0;
	private int iconInd = 0;

	@Override
	public void start(Stage stage) {

		final BorderPane root = new BorderPane();
		int DIST = 10;
		root.setPadding(new Insets(DIST, DIST, DIST, DIST));
		final VBox vbox = new VBox(DIST);

		final String lblPrefix = "Zählerstand: ";
		final Label lblText = new Label(lblPrefix + "0");
		lblText.setAlignment(Pos.CENTER_LEFT);
		
		final Image[] icons = new Image[3];
		icons[0] = new Image(getClass().getResourceAsStream("duke.png"));
		icons[1] = new Image(getClass().getResourceAsStream("fight.gif"));
		icons[2] = new Image(getClass().getResourceAsStream("snooze.gif"));
		final ImageView imageView = new ImageView(icons[0]);
		imageView.fitHeightProperty().bind(root.heightProperty().subtract(2*DIST));
		final Label lblIcon = new Label();
		lblIcon.setGraphic(imageView);
//		Label lblIcon = new Label("Duke");
//		lblIcon.setContentDisplay(ContentDisplay.BOTTOM);
//		lblIcon.setGraphicTextGap(10);
		
		
		final Button btnAdd = new Button("Zählerstand _erhöhen");
		btnAdd.setOnAction(event -> {
			numClicks++;
			lblText.setText(lblPrefix + numClicks);
			if (iconInd < icons.length-1)
				iconInd++;
			else
				iconInd = 0;
			imageView.setImage(icons[iconInd]);
		});
		btnAdd.setMnemonicParsing(true); // Kurzwahldefinition per Unterstrich aktivieren
		btnAdd.setDefaultButton(true);  // Der Default Button kann per Enter-Taste ausgelöst werden.
		
		vbox.getChildren().addAll(btnAdd, lblText);
		vbox.setAlignment(Pos.CENTER);
		root.setLeft(vbox);
		root.setCenter(lblIcon);

		Scene scene = new Scene(root, 340, 150);
		stage.setScene(scene);
		stage.setTitle("Multi Purpose Counter");
		stage.show();
	}

	public static void main(String[] args) {
		launch(args);
	}
}
