public class R2Vec {
	public double x = 1.0, y;
	// Datenkapselung ist hier nicht erforderlich, weil auf beide Koordinaten Lese- und
	// Schreibzugriff erlaubt werden soll und eine Änderung des Datentyps nicht in Frage kommt.
	
	public R2Vec(double xpar, double ypar) {
		x = xpar;
		y = ypar;
	}
	
	public R2Vec() {}
	
	public double laenge() {
		return Math.sqrt(x*x + y*y);
	}

	public void norm() {
		double b = laenge();
		x /= b;
		y /= b;				
	}

	public void add(R2Vec vpar) {
		x += vpar.x;
		y += vpar.y;
	}

	public double skalProd(R2Vec vpar) {
		return x*vpar.x + y*vpar.y;
	}

	public double winkel(R2Vec vpar) {
		return Math.toDegrees(Math.acos(skalProd(vpar)/(laenge()*vpar.laenge())));
	}

	public void drehe(double grad) {
		double cosa = Math.cos(Math.toRadians(grad));
		double sina = Math.sin(Math.toRadians(grad));
		double oldx = x;
		x = cosa*x - sina*y;
		y = sina*oldx + cosa*y;
	}
}