import java.math.BigDecimal;
import java.util.stream.IntStream;

class FJuPS {
	public static void main(String[] args) {
		int argument = 50_000;
		int schwelle = 100;
		long zeit;
		BigDecimal ergebnis; 

		// Fakultät per Fork-Join - Framework
//		for (int i = 0; i < 5; i++) {
//			zeit = System.currentTimeMillis();
//			ergebnis = FacForkJoin.factorial(argument, schwelle);
//			System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:\t%d \t(Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
//		}		

		// Fakultät per Fork-Join - Framework (automatische Schwellenberechnung)
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = FacForkJoin.factorial(argument);
			System.out.printf("\nLaufzeit mit Fork-Join in Millisekunden:\t%d \t(Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
		}		
		
		// Single-Thread, weil die Aufgabenaufteilung durch den Schwellenwert verhindert wird
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = FacForkJoin.factorial(argument, 100_000);
			System.out.printf("\nLaufzeit Single-Thread in Millisekunden:\t%d \t(Ergebnis: %e)", (System.currentTimeMillis()-zeit), ergebnis);
		}
		
		// Fakultät mit einem parallelen Strom
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = IntStream
					.rangeClosed(1, argument)
					.parallel()
					.mapToObj(BigDecimal::new)
					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
			System.out.printf("\nLaufzeit mit parallelem Strom in Millisekunden:\t%d \t(Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
		}

		// Fakultät mit einem seriellen Strom
		System.out.println("\n");
		for (int i = 0; i < 5; i++) {
			zeit = System.currentTimeMillis();
			ergebnis = IntStream
					.rangeClosed(1, argument)
					.mapToObj(BigDecimal::new)
					.reduce(BigDecimal.ONE, (c,x) -> c.multiply(x));
			System.out.printf("\nLaufzeit mit seriellem Strom in Millisekunden:\t%d \t(Ergebnis: %e)", System.currentTimeMillis()-zeit, ergebnis);
		}
	}
}
