import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;

import javax.swing.*;

class JListDnD  {
	JListDnD() {
		final String titel = "JList Drag&Drop";
		final JFrame frame = new JFrame(titel);
		final Container cont = frame.getContentPane();
		cont.setLayout(new GridLayout(1,0,10,0));
	
		final DefaultListModel<String> modelLinks = new DefaultListModel<String>();
		modelLinks.addElement("Emma"); modelLinks.addElement("Wolle");
		modelLinks.addElement("Brina");
		final JList<String> listeLinks = new JList<String>(modelLinks);
		listeLinks.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		// Dieser Aufruf sorgt, dafür, dass das JList<String> - Objekt die Drag-Geste erkennt:
		listeLinks.setDragEnabled(true);
		listeLinks.setDropMode(DropMode.ON_OR_INSERT);

		final DefaultListModel<String> modelRechts = new DefaultListModel<String>();
		modelRechts.addElement("Diego");
		final JList<String> listeRechts = new JList<String>(modelRechts);
		listeRechts.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		listeRechts.setDragEnabled(true);
		listeRechts.setDropMode(DropMode.ON_OR_INSERT);

		final JScrollPane jspLinks = new JScrollPane(listeLinks);
		jspLinks.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		final JScrollPane jspRechts = new JScrollPane(listeRechts);
		jspRechts.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		cont.add(jspLinks, BorderLayout.WEST);
		cont.add(jspRechts, BorderLayout.EAST);
		
		final ListTransferHandler lth = new ListTransferHandler();
		listeLinks.setTransferHandler(lth);
		listeRechts.setTransferHandler(lth);
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setMinimumSize(new Dimension(240, 130));
		frame.setVisible(true);
	}
	
	public static void main(String[] args) {
		new JListDnD();
	}

	@SuppressWarnings("serial")
	private class ListTransferHandler extends TransferHandler {
		private JList<String> quellListe, zielListe;
		private int quellIndex, zielIndex;
		
		@Override
		public int getSourceActions(JComponent quelle) {
			return TransferHandler.COPY_OR_MOVE;
		}
	
		@SuppressWarnings("unchecked")
		@Override
		protected Transferable createTransferable(JComponent quelle) {
			quellListe = (JList<String>) quelle;
			quellIndex = quellListe.getSelectedIndex(); 
			return new StringSelection(quellListe.getSelectedValue());
		}
	    
		@Override
		protected void exportDone(JComponent quelle, Transferable data, int action) {
			if (action == TransferHandler.MOVE) {
				if (zielListe == quellListe  &&  zielIndex < quellIndex)
					quellIndex++;
				((DefaultListModel<String>) quellListe.getModel()).remove(quellIndex);
			}
		}
	
		@Override
		public boolean canImport(TransferHandler.TransferSupport info) {
			if (info.isDataFlavorSupported(DataFlavor.stringFlavor))
				return true;
			else
				return false;
		}
	    
		@SuppressWarnings("unchecked")
		@Override
		public boolean importData(TransferHandler.TransferSupport info) {
			final JList.DropLocation dl = (JList.DropLocation) info.getDropLocation();
			zielListe = (JList<String>) info.getComponent();
			
			// Model-Objekt zur Ziel-Liste ermitteln
			final DefaultListModel<String> listModel = (DefaultListModel<String>) zielListe.getModel();
			// An welcher Position soll eingefügt werden?
			zielIndex = dl.getIndex();
			
			// Daten übernehmen und einfügen
			final Transferable t = info.getTransferable();
			String element;
			try {
				element = (String) t.getTransferData(DataFlavor.stringFlavor);
			} catch (final Exception e) { return false; }
			listModel.add(zielIndex, element);

			return true;
		}
	}
}