import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class EventID {
	private final JFrame frame;
	private final JButton cbSchalter;
	private final JLabel lblIcon;
	private final JLabel lblEvent;

    EventID() {
        frame = new JFrame("Ereignis-Kennungen");
        cbSchalter = new JButton("Knopf");
        frame.add(cbSchalter, BorderLayout.WEST);

		lblIcon = new JLabel(new ImageIcon("duke.gif"));
		frame.add(lblIcon, BorderLayout.CENTER);

        lblEvent = new JLabel();
        frame.add(lblEvent, BorderLayout.SOUTH);
        lblEvent.setHorizontalAlignment(JTextField.CENTER);

        cbSchalter.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            	lblEvent.setText("Schalter gedrückt: "+String.valueOf(e.getID()));
            }
        });
        lblIcon.addMouseListener(new MausLi());
		cbSchalter.addKeyListener(new KeyLi());
		
		frame.addWindowListener(new WinLi());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(500, 200);
		frame.setVisible(true);
    }

    public static void main(String[] args) {
        new EventID();
    }

	private class MausLi extends MouseAdapter {
		@Override
		public void mousePressed(MouseEvent e) {
			lblEvent.setText("Maustaste "+String.valueOf(e.getButton())+" gedrückt: "+String.valueOf(e.getID()));
		}
		@Override
		public void mouseReleased(MouseEvent e) {
			lblEvent.setText("Maustaste "+String.valueOf(e.getButton())+" losgelassen: "+String.valueOf(e.getID()));
		}
	}

	private class KeyLi extends KeyAdapter {
           @Override
		public void keyPressed(KeyEvent e) {
              lblEvent.setText("Taste gedrückt: "+String.valueOf(e.getID()));
           }
           @Override
		public void keyReleased(KeyEvent e) {
              lblEvent.setText("Taste losgelassen: "+String.valueOf(e.getID()));
           }
	}

	private class WinLi extends WindowAdapter {
		@Override
		public void windowActivated(WindowEvent e) {
			lblEvent.setText("Fenster aktiviert: "+String.valueOf(e.getID()));
		}
		@Override
		public void windowClosing(WindowEvent e) {
            JOptionPane.showMessageDialog(null, "Das Rahmenfenster wird geschlossen");
		}
	}
}
