import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class JComboBoxDemo {
	JComboBoxDemo() {
		final String titel = "JComboBox-Demo";
		final JFrame frame = new JFrame(titel);
		final Container cont = frame.getContentPane();

		final JLabel label = new JLabel("Wie lautet Ihr Familienname?");		
		label.setHorizontalAlignment(JTextField.CENTER);
		label.setBorder(BorderFactory.createEmptyBorder(10, 0, 0, 0));
		cont.add(label, BorderLayout.NORTH);

		final String[] auswahl = {"Müller", "Meyer", "Schmitt", "Schulze"};
		final JComboBox<String> name = new JComboBox<String>(auswahl);
		name.setMaximumRowCount(3);
		name.setEditable(true);
		name.setSelectedItem("");

		// ohne JPanel-Hülle
//		cont.add(name, BorderLayout.CENTER);
		
		// mit JPanel-Hülle
		final JPanel pan = new JPanel();
		name.setPreferredSize(new Dimension(200, 25));
		pan.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		pan.add(name);
		cont.add(pan, BorderLayout.CENTER);

		final String lblSelectedPrefix = "Selected: ";
		final JLabel lblSelected = new JLabel(lblSelectedPrefix+"\"\"");
		lblSelected.setHorizontalAlignment(JTextField.CENTER);
		cont.add(lblSelected, BorderLayout.SOUTH);
		
		name.addItemListener(new ItemListener() {
					public void itemStateChanged(ItemEvent e) {
						if(e.getStateChange() == ItemEvent.SELECTED)
							 lblSelected.setText(lblSelectedPrefix + "\"" + e.getItem() + "\"");
					}
				});

//		name.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				lblSelected.setText(lblSelectedPrefix + "\"" + ((JComboBox)e.getSource()).getSelectedItem() + "\"");
//			}
//		});

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(300, 180);
		frame.setVisible(true);
	}
	
	public static void main(String[] args) {
		new JComboBoxDemo();
	}
}