import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

class JListDemo {
	private final DefaultListModel<String> modelLinks, modelRechts;
	private final JList<String> listLinks, listRechts;	
	
	JListDemo() {
//		private JList<String> listFest = new JList<>(new String[] {"Eimer", "Wand", "Brille"});
		final String titel = "JList-Demo";
		final JFrame frame = new JFrame(titel);
		final Container cont = frame.getContentPane();
		
		modelLinks = new DefaultListModel<String>();
		modelLinks.addElement("Emma"); modelLinks.addElement("Wolle");
		modelLinks.addElement("Brina"); modelLinks.addElement("Diego");
		listLinks = new JList<String>(modelLinks);
		listLinks.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final JPanel panListeLinks = new JPanel();
		panListeLinks.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panListeLinks.add(listLinks);
		cont.add(panListeLinks, BorderLayout.WEST);

		modelRechts = new DefaultListModel<String>();
		listRechts = new JList<String>(modelRechts);
		listRechts.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		final JPanel panListeRechts = new JPanel();
		panListeRechts.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panListeRechts.add(listRechts);
		cont.add(panListeRechts, BorderLayout.EAST);
		
		final ListSelectionHandler lsh = new ListSelectionHandler();
		listLinks.addListSelectionListener(lsh);
		listRechts.addListSelectionListener(lsh);
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
	
	public static void main(String[] args) {
		new JListDemo();
	}

	private class ListSelectionHandler implements ListSelectionListener {
		@SuppressWarnings("unchecked")
		public void valueChanged(ListSelectionEvent e) {
			if (e.getValueIsAdjusting() == true)
				return;
			if (((JList<String>)e.getSource()).getSelectedIndex() < 0) {
				return;
			}
			final String wahl = ((JList<String>)e.getSource()).getSelectedValue();
			if (e.getSource() == listLinks) {
				modelLinks.removeElement(wahl);
				modelRechts.addElement(wahl);
			} else {
				modelRechts.removeElement(wahl);
				modelLinks.addElement(wahl);
			}
		}
	}
}