import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class KeyModifiers {
	private final JFrame frame;
	private final JLabel keyCode, uChar, modifiers, keyCodeVal, uCharVal, modifiersVal,
		keyPressedEvent, keyTypedEvent, keyReleasedEvent, keyPressedEventState, keyTypedEventState, keyReleasedEventState ;

    KeyModifiers() {
        frame = new JFrame("Modifikatoren-Demo");

        keyCode = new JLabel("  Key Code:");
        uChar = new JLabel("  Unicode Character:");
        modifiers = new JLabel("  Modifiers:");
        keyCodeVal = new JLabel();
        uCharVal = new JLabel();
        modifiersVal = new JLabel();

        keyPressedEvent = new JLabel("  Key Pressed:");
        keyTypedEvent = new JLabel("  Key Typed:");
        keyReleasedEvent = new JLabel("  Key Released:");

        keyPressedEventState = new JLabel("");
        keyTypedEventState = new JLabel("");
        keyReleasedEventState = new JLabel("");

        final Container cont = frame.getContentPane();
        cont.setLayout(new GridLayout(3,0));
        cont.add(keyCode); cont.add(keyCodeVal); cont.add(keyPressedEvent); cont.add(keyPressedEventState);
        cont.add(uChar); cont.add(uCharVal); cont.add(keyTypedEvent); cont.add(keyTypedEventState);
        cont.add(modifiers); cont.add(modifiersVal); cont.add(keyReleasedEvent); cont.add(keyReleasedEventState);

        frame.addKeyListener(new KeyAdapter() {
        	@Override
			public void keyPressed(KeyEvent e) {
        		keyReleasedEventState.setText("no");
        		keyPressedEventState.setText("yes");
        		uCharVal.setText("''");
				keyCodeVal.setText(String.valueOf(e.getKeyCode()));
				modifiersVal.setText(KeyEvent.getKeyModifiersText(e.getModifiers()));
            }
			@Override
			public void keyTyped(KeyEvent e) {
        		keyTypedEventState.setText("yes");
				uCharVal.setText("'"+String.valueOf(e.getKeyChar())+"'");
            }
			@Override
			public void keyReleased(KeyEvent e) {
        		keyPressedEventState.setText("no");
        		keyTypedEventState.setText("no");
        		keyReleasedEventState.setText("yes");
				keyCodeVal.setText("");
				uCharVal.setText("''");
				keyCodeVal.setText(String.valueOf(e.getKeyCode()));
				modifiersVal.setText("");
            }
        });

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(500, 100);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        new KeyModifiers();
    }
}
