import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;

class BorderLayoutDemo implements ActionListener {
	private final JFrame frame;
	private final JButton[] butt;
	private final String[] names = {"Norden verstecken", "Süden verstecken", "Osten verstecken",
							  "Westen verstecken", "Zentrum verstecken"};
	private final BorderLayout layout = new BorderLayout(5,5);
	
	BorderLayoutDemo() {
		frame = new JFrame("BorderLayoutDemo");

		final Container cont = frame.getContentPane();
		cont.setLayout(new BorderLayout(5,5));
		
		butt = new JButton[names.length];
		
		for (int i = 0; i < names.length; i++) {
			butt[i] = new JButton(names[i]);
			butt[i].addActionListener(this);
		}

		cont.add(butt[0], BorderLayout.NORTH);
		cont.add(butt[1], BorderLayout.SOUTH);
		cont.add(butt[2], BorderLayout.EAST);
		cont.add(butt[3], BorderLayout.WEST);
		cont.add(butt[4], BorderLayout.CENTER);

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(500, 200);
		frame.setVisible(true);
	}

	public void actionPerformed(ActionEvent e) {
		for (int i = 0; i < butt.length; i++)
			if (e.getSource() == butt[i])
				butt[i].setVisible(false);
			else
				butt[i].setVisible(true);
		layout.layoutContainer(frame.getContentPane());
	}

	public static void main(String[] arg) {
		new BorderLayoutDemo();
	}
}