import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

class FlowLayoutDemo {
	private final JFrame frame;
	private final JButton left, center, right;
	private final FlowLayout layout = new FlowLayout();
	private final Container cont;
	
	FlowLayoutDemo() {
		frame = new JFrame("FlowLayout-Demo");
		cont = frame.getContentPane();
		cont.setLayout(layout);
		
		left = new JButton("linksbündig");
		left.addActionListener(new
			ActionListener() {
				public void actionPerformed(ActionEvent e) {
					layout.setAlignment(FlowLayout.LEFT);
					layout.layoutContainer(cont);
				}
			});
		cont.add(left);

		center = new JButton("zentriert");
		center.addActionListener(new
			ActionListener() {
				public void actionPerformed(ActionEvent e) {
					layout.setAlignment(FlowLayout.CENTER);
					layout.layoutContainer(cont);
				}
			});
		cont.add(center);		

		right = new JButton("rechtsbündig");
		right.addActionListener(new
			ActionListener() {
				public void actionPerformed(ActionEvent e) {
					layout.setAlignment(FlowLayout.RIGHT);
					layout.layoutContainer(cont);
				}
			});
		cont.add(right);

		frame.setSize(300, 100);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public static void main(String[] arg) {
		new FlowLayoutDemo();
	}
}