import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class MPCPro {
	private int numClicks = 0;

	MPCPro() {
		final String labelPrefix = "Zählerstand: ";
		final String titel = "Multi Purpose Counter";
		
		final JFrame frame = new  JFrame(titel);

		final Container cont = frame.getContentPane();

		final JLabel lblCounter = new JLabel(labelPrefix + "0    ");
		lblCounter.setFont(new Font(Font.SANS_SERIF, Font.BOLD, 16));

		final JButton cbCount = new JButton("Zählerstand erhöhen");
		cbCount.setMnemonic(KeyEvent.VK_S);
		frame.getRootPane().setDefaultButton(cbCount);
		cbCount.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				numClicks++;
				lblCounter.setText(labelPrefix + numClicks);
			}
		});

		final JButton cbReset = new JButton("Zählerstand zurücksetzen");
		cbReset.setMnemonic(KeyEvent.VK_R);
		cbReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				numClicks = 0;
				lblCounter.setText(labelPrefix + numClicks);
			}
		});

		final JButton cbExit = new JButton("Programm beenden");
		cbExit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		
		final JPanel panCenter = new JPanel();
		panCenter.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panCenter.setLayout(new GridLayout(0, 1));

		panCenter.add(cbCount);
		panCenter.add(lblCounter);
		
		cont.add(panCenter, BorderLayout.CENTER);

		final JPanel panSouth = new JPanel();
		panSouth.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panSouth.setLayout(new GridLayout(1, 0, 5, 5));
		panSouth.add(cbReset);
		panSouth.add(cbExit);
		cont.add(panSouth, BorderLayout.SOUTH);
		
		frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		frame.setMinimumSize(new Dimension(400, 200));		
		frame.setSize(400, 200);
		frame.setVisible(true);
	}

	public static void main(String[] args) {
		new MPCPro();
	}
}
