import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

class MouseEventDemo implements MouseListener, MouseMotionListener {
	private final JFrame frame;
	private final JLabel status = new JLabel();
	private final Color defColor;
	
	MouseEventDemo() {
		frame = new JFrame("MouseEvent-Demo");

		status.setHorizontalAlignment(SwingConstants.CENTER);
		frame.getContentPane().add(status, BorderLayout.CENTER);
		
		frame.addMouseListener(this);
		frame.addMouseMotionListener(this);
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		defColor = frame.getContentPane().getBackground();
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(300, 100);
		frame.setVisible(true);
	}

	public void mouseClicked(MouseEvent e) {
		status.setText("Mausklick bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mousePressed(MouseEvent e) {
		frame.getContentPane().setBackground(Color.RED);
		status.setText("Maustaste gedrückt bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseReleased(MouseEvent e) {
		frame.getContentPane().setBackground(defColor);
	}
	public void mouseEntered(MouseEvent e) {
		status.setText("Maus eingedrungen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseExited(MouseEvent e) {
		status.setText("Maus entwichen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseDragged(MouseEvent e) {
		status.setText("Maus gezogen bei ("+e.getX()+", "+e.getY()+")");
	}
	public void mouseMoved(MouseEvent e) {
		status.setText("Maus bewegt bei ("+e.getX()+", "+e.getY()+")");
	}

	public static void main(String[] arg) {
		new MouseEventDemo();
	}
}
