import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Umschalter {
	private final JCheckBox chkBold, chkItalic;
	private final JRadioButton rbSans, rbSerif, rbMono;
	private final JLabel lblBeispiel;
	private final Font fontSans = new Font(Font.SANS_SERIF, Font.PLAIN, 16),
					   fontSerif = new Font(Font.SERIF, Font.PLAIN, 16),
					   fontMono = new Font(Font.MONOSPACED, Font.PLAIN, 16);
		
	Umschalter() {
		final JFrame frame = new JFrame("JCheckBox und JRadioButton");
		final Container cont = frame.getContentPane();
		cont.setLayout(new GridLayout(1, 0));

		final JPanel panCheck = new JPanel();
		panCheck.setLayout(new GridLayout(0, 1));
		cont.add(panCheck);

		final JPanel panRadio = new JPanel();
		panRadio.setLayout(new GridLayout(0, 1));
		cont.add(panRadio);
		
		lblBeispiel = new JLabel("Beispieltext");
		cont.add(lblBeispiel);
		lblBeispiel.setFont(fontSerif);
		
		chkBold = new JCheckBox("Fett");
		chkItalic = new JCheckBox("Kursiv");
		panCheck.add(chkBold);
		panCheck.add(chkItalic);
		
		final CheckHandler cbHandler = new CheckHandler();
		chkBold.addItemListener(cbHandler);
		chkItalic.addItemListener(cbHandler);
		
		rbSans = new JRadioButton("Sans Serif", false);
		rbSerif = new JRadioButton("Serif", true);
		rbMono = new JRadioButton("Monospaced", false);
		
		panRadio.add(rbSans);
		panRadio.add(rbSerif);
		panRadio.add(rbMono);
		
		final ButtonGroup rbGroup = new ButtonGroup();
		rbGroup.add(rbSans);
		rbGroup.add(rbSerif);
		rbGroup.add(rbMono);
		
		final RadioHandler rbHandler = new RadioHandler();
		rbSans.addItemListener(rbHandler);
		rbSerif.addItemListener(rbHandler);
		rbMono.addItemListener(rbHandler);
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		frame.setVisible(true);
	}
	
	public static void main(String[] args) {
		new Umschalter();
	}

	private class RadioHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			final int style = lblBeispiel.getFont().getStyle();
			Font font = null;
			if (e.getSource() == rbMono) {
				font = fontMono;
			} else if (e.getSource() == rbSerif) {
				font = fontSerif;
			} else if (e.getSource() == rbSans) {
				font = fontSans;
			}
			lblBeispiel.setFont(font.deriveFont(style));
		}
	}


	private class CheckHandler implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			final int oldStyle = lblBeispiel.getFont().getStyle();
			int newStyle = 0;
			
			if (e.getSource() == chkBold) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.BOLD;
				} else {
					newStyle = oldStyle - Font.BOLD;
				}
			} else if (e.getSource() == chkItalic) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					newStyle = oldStyle + Font.ITALIC;
				} else {
					newStyle = oldStyle - Font.ITALIC;
				}
			}
			lblBeispiel.setFont(lblBeispiel.getFont().deriveFont(newStyle));
		}
	}
}