import java.awt.Toolkit;
import java.awt.datatransfer.*;
import javax.swing.*;

class Zwischenablage {
	private final Clipboard clip;
	private Transferable clipContent;

	Zwischenablage() {
		final JFrame frame = new JFrame("Zwischenablage");

		final JTextPane text = new JTextPane();
		frame.getContentPane().add(new JScrollPane(text), java.awt.BorderLayout.CENTER);

		clip = Toolkit.getDefaultToolkit().getSystemClipboard();
		clip.addFlavorListener(new FlavorListener() {
			public void flavorsChanged(FlavorEvent a) {
				text.setText("");
				clipContent = clip.getContents(null);
				final StringBuffer sb = new StringBuffer("");
				for(final DataFlavor df : clipContent.getTransferDataFlavors())
					sb.append(df.getMimeType()+"   ("+df.getHumanPresentableName()+")\n");
				text.setText(sb.toString());
			}
		});
		
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(600, 400);
		frame.setVisible(true);
	}
	
	public static void main(String[] arg) {
		new Zwischenablage();
	}
}
